"use strict";

var _error = require("./error");

var _util = _interopRequireDefault(require("util"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// This is an optional module
(0, _error.E)('REDECLARE_TYPE', {
  message: 'type \'%s\' should not be declared again'
});
(0, _error.E)('UNKNOWN_TYPE', {
  message: 'unknown type \'%s\'',
  ctor: RangeError
});
(0, _error.E)('INVALID_TYPE_NAME', {
  message: 'invalid type name \'%s\'',
  ctor: TypeError
});
(0, _error.E)('NON_ARRAY_TYPES', {
  message: 'types must be an array',
  ctor: TypeError
});
(0, _error.E)('EMPTY_ARRAY_TYPE', {
  message: 'empty type array',
  ctor: TypeError
});
(0, _error.E)('INVALID_TYPE', {
  message: 'invalid type definition',
  ctor: TypeError
});
(0, _error.E)('EMPTY_TYPE', {
  message: '`any()`` should be used instead of an empty type, or type alias not found',
  ctor: TypeError
});
(0, _error.E)('INVALID_SETTER', {
  message: 'invalid setter, only functions are accepted',
  ctor: TypeError
});
(0, _error.E)('INVALID_VALIDATOR', {
  message: 'invalid validator for \'%s\', only functions or regular expressions are accepted',
  ctor: TypeError
});
(0, _error.E)('VALIDATION_FAILS', {
  message(value, key) {
    value = _util.default.inspect(value);

    if (key) {
      return _util.default.format('invalid value %s for key \'%s\'', value, key);
    }

    return _util.default.format('invalid value %s', value);
  }

});
(0, _error.E)('ASSIGN_ASYNC', {
  message: '`set()` should be used to assign new value to property of async skema'
});
(0, _error.E)('NOT_OPTIONAL', {
  message: key => _util.default.format('property %s is not optional', _util.default.inspect(key))
});
(0, _error.E)('NOT_OBJECT', {
  message: key => _util.default.format('the value of property %s is not an object', _util.default.inspect(key))
});
(0, _error.E)('NOT_WRITABLE', {
  message: 'property \'%s\' is readonly'
});
(0, _error.E)('SHAPE_NOT_FOUND', {
  message: 'shape definition not found on the object'
});