"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.attach = exports.inspect = void 0;

var _future = require("./future");

var _util = require("./util");

const isNode = typeof process !== 'undefined';

const isSkemaObject = object => !!object[_future.SHAPE];

const inspect = subject => {
  if (!(0, _util.isObject)(subject)) {
    return subject;
  }

  if (!isSkemaObject(subject)) {
    return subject;
  }

  return inspectSkemaObject(subject);
};

exports.inspect = inspect;

const inspectSkemaObject = object => Object.keys(object[_future.SHAPE]).reduce((ret, key) => {
  ret[key] = inspect(object[key]);
  return ret;
}, {});

function inspectSelf() {
  return inspectSkemaObject(this);
}

const attach = isNode ? object => {
  (0, _util.defineValue)(object, _future.CUSTOM_INSPECT_SYMBOL, inspectSelf);
} : _util.NOOP;
exports.attach = attach;